Module GlobalConstants
   Implicit None

   Real*8 :: pi , machine_precision , machine_zero , machine_infinity

   Real*8, private :: minlog,maxlog,minexp,maxexp
   Real*8, private :: minlogarg,maxlogarg,minexparg,maxexparg

 Contains

!****************************************************
 Subroutine Init_GlobalConstants

   Integer :: i
   Real*8    :: tmp , a1,a2,a3

   ! Calculate machine accuracy
   machine_precision = 0
   a1 = 4.d0/3.d0
   do while (machine_precision == 0.d0)
      a2 = a1 - 1.d0
      a3 = a2 + a2 + a2
      machine_precision = ABS(a3 - 1.d0)
   enddo

      machine_zero= machine_precision**4
      machine_infinity = 1.d0/machine_zero
   
   pi = acos(-1.d0)

   minlogarg=machine_precision; minlog=log(minlogarg)
   maxlogarg=1.d0/machine_precision; maxlog=log(maxlogarg)
   minexparg=log(machine_precision);  minexp=0.d0
   maxexparg=-log(machine_precision);  maxexp=exp(maxexparg)
   

   Return
   End Subroutine

!****************************************************
 Function ddlog(arg)
   Real*8 :: arg,ddlog

   If (arg>maxlogarg) then
      ddlog=maxlog
   Else if (arg<minlogarg) then
      ddlog=minlog
   Else
      ddlog=log(arg)
   EndIf

 Return
 End Function
 
!****************************************************
 Function ddexp(arg)
   Real*8 :: arg,ddexp

   If (arg>maxexparg) then
      ddexp=maxexp
   Else if (arg<minexparg) then
      ddexp=minexp
   Else
      ddexp=exp(arg)
   EndIf

 Return
 End Function
 
End Module
