      subroutine makeblochl(n,iiirc,nmx,mxnl,mxb,mxo,mxw,nz,itype,norbit, &
       nlst,llst,iscore,occ,eig,r,h,rv,v0,v0p,coreden,valeden,wfn,wk,   &
       nos,nop,nod,nof,nog,lmax,ntlst,ltlst,nbl,kpow,nbase,zcore,zvale,vlocfac, &
       cp,hatpot,vloc,beig,bocc,phi,tphi,tp,tvaleden,denout,rveff,      &
       nclst,lclst,mapbv,nvorbit,psi,tpsi,veig,vocc,ophi,otphi,otp,shape)

!  Version using Blochl's form of projector and orthogonalization procedure
!   At the end of this subroutine, the basis functions and projectors are
!    orthogonalized
!  program to generate atomic basis functions for Blochl's paw formalism
!    starting with the self-consistent density functional
!    atom ground state for atom with atomic number nz, ionic charge qion
!    choose bound and continuum basis functions phi
!    accumulate core and valence densities
!  iiirc == index of last calculated value of 'unbound' basis functions --
!   allows for choosing positive energy basis functions which are not
!    necessarily bound states
      implicit real*8 (a-h,o-z)
      character*1 answer
      real*8 :: occ(mxo),eig(mxo),wk(nmx,mxw),r(nmx),vocc(mxo),veig(mxo)
      real*8 :: wfn(nmx,mxo),dum(nmx),shape(nmx)
      real*8 :: rv(nmx),valeden(nmx),coreden(nmx)
      real*8 :: phi(nmx,mxo),tphi(nmx,mxo),tp(nmx,mxo),psi(nmx,mxo)
      real*8 :: ophi(nmx,mxo),otphi(nmx,mxo),otp(nmx,mxo)
      real*8 :: hatpot(nmx),rveff(nmx),cp(mxo),tpsi(nmx,mxo)
      real*8 :: beig(mxo),bocc(mxo),tvaleden(nmx),denout(nmx),vloc(nmx)
      integer :: nlst(mxo),llst(mxo),iscore(mxo)  !enumerates original config
      integer :: ntlst(mxo),ltlst(mxo),nbl(mxnl)  !enumerates basis functions
      integer :: nclst(mxo),lclst(mxo),mapbv(mxo) !enumerates bound states
      integer :: ins    ! index to set vlocfac
      integer :: ivfac,iv  ! if vlocfac==0, reset based on valence s state

      nbase=0
      nbl=0
      nvorbit=0
      ivfac=1
      if (abs(vlocfac)<1.d-7) ivfac=2

       write(6,*) '  basis functions:'
       write(6,*)' No.   n     l         energy         occ   '
       do l=0,lmax


         do io=1,norbit    ! cycle through all configuration

           if (llst(io).eq.l.and.iscore(io).eq.1) then

            nbase=nbase+1
            if (ivfac==2 .and. l==0) then
               ins=nbase
               write(6,*) ' Index of valence s orbital is ', nbase
            endif
            ltlst(nbase)=l
            ntlst(nbase)=nlst(io)
            beig(nbase)=eig(io)
            bocc(nbase)=occ(io)
            phi(1:n,nbase)=wfn(1:n,io)
            nbl(l+1)=nbl(l+1)+1
            nvorbit=nvorbit+1
            veig(nvorbit)=eig(io)
            vocc(nvorbit)=occ(io)
            psi(1:n,nvorbit)=wfn(1:n,io)
            lclst(nvorbit)=l
            nclst(nvorbit)=nlst(io)
            mapbv(nvorbit)=nbase

            write(6,'(3i4,1p2e15.6)') nbase,ntlst(nbase),l,             &
                beig(nbase),bocc(nbase)

           endif

         enddo
!
       generalizedloop: do
       write(6,*) 'For l = ',l,' there are currently ',nbl(l+1),&
         'basis functions'
       write(6,*) 'enter y to add additional functions or n to ' &
           ,'go to next l'
       read(5,*) answer
       if (answer.ne.'y') exit generalizedloop
       write(6,*) 'enter energy for generalized function'
       read(5,*) energy
       if(energy.lt.0.d0) then
         write(6,*) 'energy is negative',energy,' -- program terminated'
         stop
         endif
        nbase=nbase+1
        nbl(l+1)=nbl(l+1)+1
        ltlst(nbase)=l
        ntlst(nbase)=999
        beig(nbase)=energy
        bocc(nbase)=0.d0
        phi(1:n,nbase)=0.d0
       call unboundsch(n,energy,nmx,phi(1,nbase),l,nz,rv,h,v0,v0p,node, &
         wk,wk(1,2))
       rat=max(abs(phi(iiirc,nbase)),abs(phi(iiirc+1,nbase)))
       rat=DSIGN(rat,phi(iiirc,nbase))
       phi(1:n,nbase)=phi(1:n,nbase)/rat

            write(6,'(3i6,1p2e15.6)') nbase,ntlst(nbase),l,             &
                beig(nbase),bocc(nbase)

       enddo generalizedloop
!

       enddo   ! end lmax loop



       nos=0
       nop=0
       nod=0
       nof=0
       nog=0

       do l=0,lmax
        if(l.eq.0) nos=nbl(l+1)
        if(l.eq.1) nop=nbl(l+1)
        if(l.eq.2) nod=nbl(l+1)
        if(l.eq.3) nof=nbl(l+1)
        if(l.eq.4) nog=nbl(l+1)
       enddo

       write(6,*) 'completed phi basis with ',nbase,' functions '

         do ib=1,nbase
          tphi(1:n,ib)=phi(1:n,ib)
            enddo

       tvaleden=0
       do io=1,nvorbit
         ib=mapbv(io)
         tpsi(1:n,io)=tphi(1:n,ib)
         do i=1,n
         tvaleden(i)=tvaleden(i)+vocc(io)*(tpsi(i,io)**2)
         enddo
       enddo
         delta=1.d10

    do iv=1,ivfac
         thisconv=nbase*1.d-9
         niter=100
         loop=0
!
!  iteration for tphi functions
!
       tphiloop: do

        loop=loop+1
          if (loop.gt.niter) then
           write(6,*) 'program terminating in tphiloop with loop=',loop
           stop
          endif

!
      do i=1,n
       denout(i)=coreden(i)+valeden(i)-tvaleden(i)
       enddo
!
      do i=1,n
       dum(i)=tvaleden(i)
       enddo

      qeff=-nz+overint(n,h,denout)
      write(6,*) 'qeff = ',qeff
      tq=overint(n,h,tvaleden)
      write(6,*) 'tq  = ',tq
!
       ttq=overint(n,h,dum)
        write(6,*) 'ttq = ',ttq
        q00=-nz+zcore+zvale-ttq
         write(6,*) 'q00 = ',q00
!  generate effective potential
!
      noz=0
      call potential(n,h,noz,ttq,dum,rveff,tecoul,tetxc,teexc,          &
        tv0,tv0p,wk,wk(1,2),wk(1,3),wk(1,4),itype)
!


      do i=1,n
      rveff(i)=rveff(i)+q00*hatpot(i)+vloc(i)*r(i)
      enddo

! correct tilde v0

      tv0=tv0+vlocfac+q00*(hatpot(3)/3+3*(hatpot(1)-hatpot(2)/2))/h


       if (loop.gt.4.and.delta.lt.thisconv) then
        write(6,*) 'projectors converged with loop,delta = ', loop,delta
        exit tphiloop
        endif
!
!   form projector functions
!

!
      write(6,*) '--- loop  ',loop, '    kpow ',kpow

      call formbprojector(nbase,nos,nop,nod,nof,nog,n,h,mxnl,           &
        iiirc,r,nmx,mxo,phi,tphi,tp,rveff,tv0,beig,mxb,cp,ophi,otphi,otp,shape)
!
!
       denout=0
       do io=1,nvorbit
         ib=mapbv(io)
         tpsi(1:n,io)=tphi(1:n,ib)
         do i=1,n
         denout(i)=denout(i)+vocc(io)*(tpsi(i,io)**2)
         enddo
       enddo

      dum(1:n)=denout(1:n)-tvaleden(1:n)
      delta=sqrt(dot_product(dum(1:n),dum(1:n)))
      write(6,*) ' loop = ',loop, 'delta = ' ,delta
      tvaleden(1:n)=denout(1:n)

      enddo tphiloop

   if (ivfac==2 .and. iv==1) then
      write(6,*) 'Completed first tphiloop ',cp(1:nbase)
     vlocfac=-cp(ins)
     vloc=vlocfac*shape
     write(6,*) 'Resetting vlocfac == ', vlocfac
   endif

 enddo ! iv loop

        do io=1,nvorbit
          ib=mapbv(io)
           tpsi(1:n,io)=tphi(1:n,ib)
          enddo


       return
        end
