        function overlap(n,h,f1,f2)
!   function to calculate the overlap between two vectors f1 and f2
!      using simpsons rule, assuming f1(0)*f2(0)=0
!      assumes f1, f2 tabulated at points r=i*h
        implicit none
        real*8 :: overlap
        integer, intent(IN) :: n
        real*8, intent(IN) :: h, f1(n),f2(n)
 
        integer :: i,j
        real*8 :: fac

        if (n==1) then
          overlap=h*f1(1)*f2(1)/2
          return
        endif
        fac=h/3
        overlap=4*f1(1)*f2(1)+f1(2)*f2(2)
        j=(n/2)*2
        if(j>=4) then
         do i=4,j,2
           overlap=overlap+f1(i-2)*f2(i-2)+4*f1(i-1)*f2(i-1)+f1(i)*f2(i)
         enddo
         overlap=fac*overlap
        endif
        if (n>j) then
         overlap=overlap+h*(f1(j)*f2(j)+f1(n)*f2(n))/2
        endif
        return
         end
